routes/web.php
<?php

use App\Services\CodeService;

Auth::routes();

Route::middleware('auth')->group(function () {

    Route::get('/', 'HomeController@index')->name('home');
    Route::get('/profile', 'HomeController@index')->name('profile');
    Route::resource('codes', 'CodeController')->except(['show']);
    Route::resource('users', 'UserController')->except(['show']);

    Route::get('/codes/reset', function(CodeService $codeService) {
        $codeService->resetSerialNumbers();
        return redirect(route('codes.index'));
    })->name('codes.reset');

});

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The table schema.
     */

    const TABLE_NAME = 'users';

    const FIELD_PK = 'id';
    const FIELD_NAME = 'name';
    const FIELD_EMAIL = 'email';
    const FIELD_PASSWORD = 'password';
    const FIELD_REMEMBER_TOKEN = 'remember_token';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        self::FIELD_NAME,
        self::FIELD_EMAIL,
        self::FIELD_PASSWORD,
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        self::FIELD_PASSWORD,
        self::FIELD_REMEMBER_TOKEN,
    ];

    /*
	|--------------------------------------------------------------------------
	| Getters
	|--------------------------------------------------------------------------
    */

    /**
     * Get the user id.
     *
     * @return int
     */
    public function getId()
    {
        return (int) $this->getAttribute(static::FIELD_PK);
    }

    /**
     * Get the name of the user.
     *
     * @return mixed
     */
    public function getName()
    {
        return $this->getAttribute(static::FIELD_NAME);
    }

    /**
     * Get the email of the user.
     *
     * @return mixed
     */
    public function getEmail()
    {
        return $this->getAttribute(static::FIELD_EMAIL);
    }

    /**
     * Get the password of the user.
     *
     * @return mixed
     */
    public function getPassword()
    {
        return $this->getAttribute(static::FIELD_PASSWORD);
    }

    /*
	|--------------------------------------------------------------------------
	| Setters
	|--------------------------------------------------------------------------
    */

    /**
     * Set the name of the user.
     *
     * @param string $name
     */
    public function setName(string $name)
    {
        $this->setAttribute(static::FIELD_NAME, $name);
    }

    /**
     * Set the email of the user.
     *
     * @param string $email
     */
    public function setEmail(string $email)
    {
        $this->setAttribute(static::FIELD_EMAIL, $email);
    }

    /**
     * Set the password of the user.
     *
     * @param string $password
     */
    public function setPassword(string $password)
    {
        $this->setAttribute(static::FIELD_PASSWORD, $password);
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\UserRequest;
use App\Repositories\UserRepository;
use App\Services\UserService;
use Illuminate\Http\Request;
use Illuminate\Database\Eloquent\ModelNotFoundException;

class UserController extends Controller
{
    /**
     * @var UserService
     */
    private $userService;

    /**
     * @var UserRepository
     */
    private $userRepository;

    /**
     * Protected users ids.
     *
     * @var array
     */
    private $protectedIds = [1];

    /**
     * UserController constructor.
     *
     * @param UserService $userService
     * @param UserRepository $userRepository
     */
    public function __construct(UserService $userService, UserRepository $userRepository)
    {
        set_search_action(route('users.index'));

        $this->userService = $userService;
        $this->userRepository = $userRepository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        set_title(trans('nav.users'));

        $searchQuery = request(KEYWORD_SEARCH_QUERY);

        if ($searchQuery) {
            $users = $this->userService->search($searchQuery);
        } else {
            $users = $this->userService->all(25, $this->protectedIds);
        }

        return view('users.index')->with(compact('users', 'searchQuery'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        set_title(trans('users.create_user'));

        return view('users.create-edit');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param UserRequest|Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(UserRequest $request)
    {
        set_title(trans('nav.codes'));

        try {

            if ($this->userService->create(
                request('name'),
                request('email'),
                request('password')
            )) {
                return redirect_success(route('users.index'), trans('users.create_success'));
            }

            return redirect_fail(route('users.create'), trans('users.create_fail'));

        } catch (\Exception $exception) {
            return redirect_fail(route('users.create'), trans('misc.database_exception'));
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        set_title(trans('users.edit_user'));

        enable_edit_mode();

        try {

            // Throw an exception if the user is not editable.
            if ( ! $this->userEditable($id)) {
                throw new ModelNotFoundException();
            }

            $user = $this->userRepository->find($id);

            return view('users.create-edit')->with(compact('user'));

        } catch (ModelNotFoundException $exception) {
            return redirect_fail(route('users.index'), trans('users.user_not_found'));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param UserRequest|Request $request
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update(UserRequest $request, $id)
    {
        try {

            // Throw an exception if the user is not editable.
            if ( ! $this->userEditable($id)) {
                throw new ModelNotFoundException();
            }

            if ($this->userService->update(
                $id,
                request('name'),
                request('email'),
                request('password')
            )) {
                return redirect_success(route('users.index'), trans('users.update_success'));
            }

            return redirect_fail(route('users.update'), trans('users.update_fail'));

        } catch (\Exception $exception) {
            return redirect_fail(route('users.update'), trans('misc.database_exception'));
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try {

            // Let's make sure that the user don't delete himself/herself.
            array_push($this->protectedIds, auth()->user()->getAuthIdentifier());

            // Throw an exception if the user is not editable.
            if ( ! $this->userEditable($id)) {
                throw new ModelNotFoundException();
            }

            if ($this->userService->delete($id)) {
                return redirect_success(route('users.index'), trans('users.delete_success'));
            }

            return redirect_fail(route('users.index'), trans('users.delete_fail'));

        } catch (\Exception $exception) {
            return redirect_fail(route('users.index'), trans('misc.database_exception'));
        }
    }

    /**
     * Check if the user is editable.
     *
     * @param $id
     * @return bool
     */
    private function userEditable($id)
    {
        return ! in_array($id, $this->protectedIds);
    }
}

resources/views/users/create-edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="row">
        <div class="col-md-8 col-md-offset-2">

            <div class="card-box">

                @empty ($editMode)
                <form action="{{ route('users.store') }}" method="post">
                @else
                <form action="{{ route('users.update', $user->getId()) }}" method="post">
                    {!! method_field('PUT') !!}
                @endif
                    {!! csrf_field() !!}

                    <div class="form-group{{ $errors->has('name') ? ' has-error' : '' }}">
                        <label for="name" class="form-label">@lang('users.name')</label>
                        <input autofocus required type="text" id="name" name="name" class="form-control" value="{{ old('name', optional(@$user)->getName()) }}">
                        @if ($errors->has('name'))
                            <span class="help-block">
                            <strong>{{ $errors->first('name') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('email') ? ' has-error' : '' }}">
                        <label for="email" class="form-label">@lang('users.email')</label>
                        <input required type="email" id="email" name="email" class="form-control" value="{{ old('email', optional(@$user)->getEmail()) }}">
                        @if ($errors->has('email'))
                            <span class="help-block">
                            <strong>{{ $errors->first('email') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <div class="form-group{{ $errors->has('password') ? ' has-error' : '' }}">
                        <label for="password" class="form-label">@lang('users.password')</label>
                        <input @empty($editMode) required @endempty type="password" id="password" name="password" class="form-control">
                        @if ($errors->has('password'))
                            <span class="help-block">
                            <strong>{{ $errors->first('password') }}</strong>
                        </span>
                        @endif
                    </div><!-- /.form-group -->

                    <input type="hidden" name="user_id" value="{{ optional(@$user)->getId() }}">

                    <button type="submit" class="btn btn-primary" name="submit">
                        @isset($editMode)
                        <i class="fa fa-pencil"></i> @lang('misc.edit')
                        @else
                        <i class="fa fa-plus-circle"></i> @lang('misc.add')
                        @endif
                    </button>
                    <button type="reset" class="btn btn-default">
                        <i class="fa fa-fw fa-refresh"></i> @lang('misc.reset')
                    </button>

                </form>
            </div><!-- /.card-box -->

        </div><!-- /.col -->
    </div><!-- /.row -->

@endsection

resources/views/users/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="m-b-25">
        <a href="{{ route('users.create') }}" class="btn btn-primary waves-effect">
            <i class="fa fa-fw fa-plus-circle"></i> @lang('users.create_user')
        </a>
    </div>

    @isset ($searchQuery)
    <div class="alert alert-info">@lang('users.search_alert_text', ['query' => $searchQuery, 'link' => route('users.index')])</div>
    @endisset

    <div class="card-box">
        <table class="table table-striped table-responsive m-b-0">
            <thead>
                <tr>
                    <th class="text-center" style="width: 1%">#</th>
                    <th>@lang('users.name')</th>
                    <th class="text-left" style="width: 25%">@lang('misc.controls')</th>
                </tr>
            </thead>
            <tbody>
                @each('users.table-row', $users, 'user', 'users.table-empty')
            </tbody>
        </table>
    </div>

    <div class="text-center">
        {{ $users->appends(['q' => $searchQuery])->links() }}
    </div>

@endsection

resources/views/users/table-empty.blade.php
<tr>
    <td colspan="6" class="text-center">@lang('users.no_users')</td>
</tr>

resources/views/users/table-row-controls.blade.php
<div class="btn-group">
    <form action="{{ route('users.destroy', $user->getId()) }}" method="post" class="form-inline">
        {{ csrf_field() }}
        {{ method_field('DELETE') }}
        <a href="{{ route('users.edit', $user->getId()) }}" class="btn btn-default btn-sm waves-effect" title="@lang('misc.edit')">
            <i class="fa fa-fw fa-pencil-square-o"></i>
        </a>
        @if ($user->getId() != auth()->user()->id)
            <button type="submit" class="btn btn-default btn-sm waves-effect waves-danger delete-btn">
                <i class="fa fa-fw fa-trash-o"></i>
            </button>
        @endif
    </form>
</div>

resources/views/users/table-row.blade.php
<tr>
    <th class="text-center" style="width: 1%" scope="row">{{ $user->getId() }}</th>
    <td>
        <span class="clearfix">{{ $user->getName() }}</span>
        <span>{{ $user->getEmail() }}</span>
    </td>
    <td class="text-left">
        @include('users.table-row-controls', ['user' => $user])
    </td>
</tr>